aboutsummaryrefslogtreecommitdiffstats
path: root/tests/unit-test-client
diff options
context:
space:
mode:
Diffstat (limited to '')
-rwxr-xr-xtests/unit-test-client225
-rw-r--r--tests/unit-test-client.c690
-rw-r--r--tests/unit-test-client.obin0 -> 43688 bytes
3 files changed, 915 insertions, 0 deletions
diff --git a/tests/unit-test-client b/tests/unit-test-client
new file mode 100755
index 0000000..4e2b561
--- /dev/null
+++ b/tests/unit-test-client
@@ -0,0 +1,225 @@
+#! /bin/bash
+
+# unit-test-client - temporary wrapper script for .libs/unit-test-client
+# Generated by libtool (GNU libtool) 2.4 Debian-2.4-3
+#
+# The unit-test-client program cannot be directly executed until all the libtool
+# libraries that it depends on are installed.
+#
+# This wrapper script should never be moved out of the build directory.
+# If it is, it will not operate correctly.
+
+# Sed substitution that helps us do robust quoting. It backslashifies
+# metacharacters that are still active within double-quoted strings.
+sed_quote_subst='s/\([`"$\\]\)/\\\1/g'
+
+# Be Bourne compatible
+if test -n "${ZSH_VERSION+set}" && (emulate sh) >/dev/null 2>&1; then
+ emulate sh
+ NULLCMD=:
+ # Zsh 3.x and 4.x performs word splitting on ${1+"$@"}, which
+ # is contrary to our usage. Disable this feature.
+ alias -g '${1+"$@"}'='"$@"'
+ setopt NO_GLOB_SUBST
+else
+ case `(set -o) 2>/dev/null` in *posix*) set -o posix;; esac
+fi
+BIN_SH=xpg4; export BIN_SH # for Tru64
+DUALCASE=1; export DUALCASE # for MKS sh
+
+# The HP-UX ksh and POSIX shell print the target directory to stdout
+# if CDPATH is set.
+(unset CDPATH) >/dev/null 2>&1 && unset CDPATH
+
+relink_command="(cd /home/jmccrohan/bin/libmodbus/tests; { test -z \"\${LIBRARY_PATH+set}\" || unset LIBRARY_PATH || { LIBRARY_PATH=; export LIBRARY_PATH; }; }; { test -z \"\${COMPILER_PATH+set}\" || unset COMPILER_PATH || { COMPILER_PATH=; export COMPILER_PATH; }; }; { test -z \"\${GCC_EXEC_PREFIX+set}\" || unset GCC_EXEC_PREFIX || { GCC_EXEC_PREFIX=; export GCC_EXEC_PREFIX; }; }; { test -z \"\${LD_RUN_PATH+set}\" || unset LD_RUN_PATH || { LD_RUN_PATH=; export LD_RUN_PATH; }; }; { test -z \"\${LD_LIBRARY_PATH+set}\" || unset LD_LIBRARY_PATH || { LD_LIBRARY_PATH=; export LD_LIBRARY_PATH; }; }; PATH=/usr/sbin:/usr/bin:/sbin:/bin:/usr/bin/X11; export PATH; gcc -g -O2 -g -O2 -Wall -Werror -o \$progdir/\$file unit-test-client.o ../src/.libs/libmodbus.so -Wl,-rpath -Wl,/home/jmccrohan/bin/libmodbus/src/.libs)"
+
+# This environment variable determines our operation mode.
+if test "$libtool_install_magic" = "%%%MAGIC variable%%%"; then
+ # install mode needs the following variables:
+ generated_by_libtool_version='2.4'
+ notinst_deplibs=' ../src/libmodbus.la'
+else
+ # When we are sourced in execute mode, $file and $ECHO are already set.
+ if test "$libtool_execute_magic" != "%%%MAGIC variable%%%"; then
+ file="$0"
+
+# A function that is used when there is no print builtin or printf.
+func_fallback_echo ()
+{
+ eval 'cat <<_LTECHO_EOF
+$1
+_LTECHO_EOF'
+}
+ ECHO="printf %s\\n"
+ fi
+
+# Very basic option parsing. These options are (a) specific to
+# the libtool wrapper, (b) are identical between the wrapper
+# /script/ and the wrapper /executable/ which is used only on
+# windows platforms, and (c) all begin with the string --lt-
+# (application programs are unlikely to have options which match
+# this pattern).
+#
+# There are only two supported options: --lt-debug and
+# --lt-dump-script. There is, deliberately, no --lt-help.
+#
+# The first argument to this parsing function should be the
+# script's ../libtool value, followed by no.
+lt_option_debug=
+func_parse_lt_options ()
+{
+ lt_script_arg0=$0
+ shift
+ for lt_opt
+ do
+ case "$lt_opt" in
+ --lt-debug) lt_option_debug=1 ;;
+ --lt-dump-script)
+ lt_dump_D=`$ECHO "X$lt_script_arg0" | /bin/sed -e 's/^X//' -e 's%/[^/]*$%%'`
+ test "X$lt_dump_D" = "X$lt_script_arg0" && lt_dump_D=.
+ lt_dump_F=`$ECHO "X$lt_script_arg0" | /bin/sed -e 's/^X//' -e 's%^.*/%%'`
+ cat "$lt_dump_D/$lt_dump_F"
+ exit 0
+ ;;
+ --lt-*)
+ $ECHO "Unrecognized --lt- option: '$lt_opt'" 1>&2
+ exit 1
+ ;;
+ esac
+ done
+
+ # Print the debug banner immediately:
+ if test -n "$lt_option_debug"; then
+ echo "unit-test-client:unit-test-client:${LINENO}: libtool wrapper (GNU libtool) 2.4 Debian-2.4-3" 1>&2
+ fi
+}
+
+# Used when --lt-debug. Prints its arguments to stdout
+# (redirection is the responsibility of the caller)
+func_lt_dump_args ()
+{
+ lt_dump_args_N=1;
+ for lt_arg
+ do
+ $ECHO "unit-test-client:unit-test-client:${LINENO}: newargv[$lt_dump_args_N]: $lt_arg"
+ lt_dump_args_N=`expr $lt_dump_args_N + 1`
+ done
+}
+
+# Core function for launching the target application
+func_exec_program_core ()
+{
+
+ if test -n "$lt_option_debug"; then
+ $ECHO "unit-test-client:unit-test-client:${LINENO}: newargv[0]: $progdir/$program" 1>&2
+ func_lt_dump_args ${1+"$@"} 1>&2
+ fi
+ exec "$progdir/$program" ${1+"$@"}
+
+ $ECHO "$0: cannot exec $program $*" 1>&2
+ exit 1
+}
+
+# A function to encapsulate launching the target application
+# Strips options in the --lt-* namespace from $@ and
+# launches target application with the remaining arguments.
+func_exec_program ()
+{
+ for lt_wr_arg
+ do
+ case $lt_wr_arg in
+ --lt-*) ;;
+ *) set x "$@" "$lt_wr_arg"; shift;;
+ esac
+ shift
+ done
+ func_exec_program_core ${1+"$@"}
+}
+
+ # Parse options
+ func_parse_lt_options "$0" ${1+"$@"}
+
+ # Find the directory that this script lives in.
+ thisdir=`$ECHO "$file" | /bin/sed 's%/[^/]*$%%'`
+ test "x$thisdir" = "x$file" && thisdir=.
+
+ # Follow symbolic links until we get to the real thisdir.
+ file=`ls -ld "$file" | /bin/sed -n 's/.*-> //p'`
+ while test -n "$file"; do
+ destdir=`$ECHO "$file" | /bin/sed 's%/[^/]*$%%'`
+
+ # If there was a directory component, then change thisdir.
+ if test "x$destdir" != "x$file"; then
+ case "$destdir" in
+ [\\/]* | [A-Za-z]:[\\/]*) thisdir="$destdir" ;;
+ *) thisdir="$thisdir/$destdir" ;;
+ esac
+ fi
+
+ file=`$ECHO "$file" | /bin/sed 's%^.*/%%'`
+ file=`ls -ld "$thisdir/$file" | /bin/sed -n 's/.*-> //p'`
+ done
+
+ # Usually 'no', except on cygwin/mingw when embedded into
+ # the cwrapper.
+ WRAPPER_SCRIPT_BELONGS_IN_OBJDIR=no
+ if test "$WRAPPER_SCRIPT_BELONGS_IN_OBJDIR" = "yes"; then
+ # special case for '.'
+ if test "$thisdir" = "."; then
+ thisdir=`pwd`
+ fi
+ # remove .libs from thisdir
+ case "$thisdir" in
+ *[\\/].libs ) thisdir=`$ECHO "$thisdir" | /bin/sed 's%[\\/][^\\/]*$%%'` ;;
+ .libs ) thisdir=. ;;
+ esac
+ fi
+
+ # Try to get the absolute directory name.
+ absdir=`cd "$thisdir" && pwd`
+ test -n "$absdir" && thisdir="$absdir"
+
+ program=lt-'unit-test-client'
+ progdir="$thisdir/.libs"
+
+ if test ! -f "$progdir/$program" ||
+ { file=`ls -1dt "$progdir/$program" "$progdir/../$program" 2>/dev/null | /bin/sed 1q`; \
+ test "X$file" != "X$progdir/$program"; }; then
+
+ file="$$-$program"
+
+ if test ! -d "$progdir"; then
+ mkdir "$progdir"
+ else
+ rm -f "$progdir/$file"
+ fi
+
+ # relink executable if necessary
+ if test -n "$relink_command"; then
+ if relink_command_output=`eval $relink_command 2>&1`; then :
+ else
+ printf %s\n "$relink_command_output" >&2
+ rm -f "$progdir/$file"
+ exit 1
+ fi
+ fi
+
+ mv -f "$progdir/$file" "$progdir/$program" 2>/dev/null ||
+ { rm -f "$progdir/$program";
+ mv -f "$progdir/$file" "$progdir/$program"; }
+ rm -f "$progdir/$file"
+ fi
+
+ if test -f "$progdir/$program"; then
+ if test "$libtool_execute_magic" != "%%%MAGIC variable%%%"; then
+ # Run the actual program with our arguments.
+ func_exec_program ${1+"$@"}
+ fi
+ else
+ # The program doesn't exist.
+ $ECHO "$0: error: \`$progdir/$program' does not exist" 1>&2
+ $ECHO "This script is just a wrapper for $program." 1>&2
+ $ECHO "See the libtool documentation for more information." 1>&2
+ exit 1
+ fi
+fi
diff --git a/tests/unit-test-client.c b/tests/unit-test-client.c
new file mode 100644
index 0000000..533e6a7
--- /dev/null
+++ b/tests/unit-test-client.c
@@ -0,0 +1,690 @@
+/*
+ * Copyright © 2008-2010 Stéphane Raimbault <stephane.raimbault@gmail.com>
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <stdio.h>
+#include <unistd.h>
+#include <string.h>
+#include <stdlib.h>
+#include <errno.h>
+#include <modbus.h>
+
+#include "unit-test.h"
+
+enum {
+ TCP,
+ TCP_PI,
+ RTU
+};
+
+int main(int argc, char *argv[])
+{
+ uint8_t *tab_rp_bits;
+ uint16_t *tab_rp_registers;
+ uint16_t *tab_rp_registers_bad;
+ modbus_t *ctx;
+ int i;
+ uint8_t value;
+ int nb_points;
+ int rc;
+ float real;
+ struct timeval old_response_timeout;
+ struct timeval response_timeout;
+ int use_backend;
+
+ if (argc > 1) {
+ if (strcmp(argv[1], "tcp") == 0) {
+ use_backend = TCP;
+ } else if (strcmp(argv[1], "tcppi") == 0) {
+ use_backend = TCP_PI;
+ } else if (strcmp(argv[1], "rtu") == 0) {
+ use_backend = RTU;
+ } else {
+ printf("Usage:\n %s [tcp|tcppi|rtu] - Modbus client for unit testing\n\n", argv[0]);
+ exit(1);
+ }
+ } else {
+ /* By default */
+ use_backend = TCP;
+ }
+
+ if (use_backend == TCP) {
+ ctx = modbus_new_tcp("127.0.0.1", 1502);
+ } else if (use_backend == TCP_PI) {
+ ctx = modbus_new_tcp_pi("::1", "1502");
+ } else {
+ ctx = modbus_new_rtu("/dev/ttyUSB1", 115200, 'N', 8, 1);
+ }
+ if (ctx == NULL) {
+ fprintf(stderr, "Unable to allocate libmodbus context\n");
+ return -1;
+ }
+ modbus_set_debug(ctx, TRUE);
+ modbus_set_error_recovery(ctx,
+ MODBUS_ERROR_RECOVERY_LINK |
+ MODBUS_ERROR_RECOVERY_PROTOCOL);
+
+ if (use_backend == RTU) {
+ modbus_set_slave(ctx, SERVER_ID);
+ }
+
+ if (modbus_connect(ctx) == -1) {
+ fprintf(stderr, "Connection failed: %s\n",
+ modbus_strerror(errno));
+ modbus_free(ctx);
+ return -1;
+ }
+
+ /* Allocate and initialize the memory to store the bits */
+ nb_points = (UT_BITS_NB > UT_INPUT_BITS_NB) ? UT_BITS_NB : UT_INPUT_BITS_NB;
+ tab_rp_bits = (uint8_t *) malloc(nb_points * sizeof(uint8_t));
+ memset(tab_rp_bits, 0, nb_points * sizeof(uint8_t));
+
+ /* Allocate and initialize the memory to store the registers */
+ nb_points = (UT_REGISTERS_NB > UT_INPUT_REGISTERS_NB) ?
+ UT_REGISTERS_NB : UT_INPUT_REGISTERS_NB;
+ tab_rp_registers = (uint16_t *) malloc(nb_points * sizeof(uint16_t));
+ memset(tab_rp_registers, 0, nb_points * sizeof(uint16_t));
+
+ printf("** UNIT TESTING **\n");
+
+ printf("\nTEST WRITE/READ:\n");
+
+ /** COIL BITS **/
+
+ /* Single */
+ rc = modbus_write_bit(ctx, UT_BITS_ADDRESS, ON);
+ printf("1/2 modbus_write_bit: ");
+ if (rc == 1) {
+ printf("OK\n");
+ } else {
+ printf("FAILED\n");
+ goto close;
+ }
+
+ rc = modbus_read_bits(ctx, UT_BITS_ADDRESS, 1, tab_rp_bits);
+ printf("2/2 modbus_read_bits: ");
+ if (rc != 1) {
+ printf("FAILED (nb points %d)\n", rc);
+ goto close;
+ }
+
+ if (tab_rp_bits[0] != ON) {
+ printf("FAILED (%0X = != %0X)\n", tab_rp_bits[0], ON);
+ goto close;
+ }
+ printf("OK\n");
+ /* End single */
+
+ /* Multiple bits */
+ {
+ uint8_t tab_value[UT_BITS_NB];
+
+ modbus_set_bits_from_bytes(tab_value, 0, UT_BITS_NB, UT_BITS_TAB);
+ rc = modbus_write_bits(ctx, UT_BITS_ADDRESS,
+ UT_BITS_NB, tab_value);
+ printf("1/2 modbus_write_bits: ");
+ if (rc == UT_BITS_NB) {
+ printf("OK\n");
+ } else {
+ printf("FAILED\n");
+ goto close;
+ }
+ }
+
+ rc = modbus_read_bits(ctx, UT_BITS_ADDRESS, UT_BITS_NB, tab_rp_bits);
+ printf("2/2 modbus_read_bits: ");
+ if (rc != UT_BITS_NB) {
+ printf("FAILED (nb points %d)\n", rc);
+ goto close;
+ }
+
+ i = 0;
+ nb_points = UT_BITS_NB;
+ while (nb_points > 0) {
+ int nb_bits = (nb_points > 8) ? 8 : nb_points;
+
+ value = modbus_get_byte_from_bits(tab_rp_bits, i*8, nb_bits);
+ if (value != UT_BITS_TAB[i]) {
+ printf("FAILED (%0X != %0X)\n", value, UT_BITS_TAB[i]);
+ goto close;
+ }
+
+ nb_points -= nb_bits;
+ i++;
+ }
+ printf("OK\n");
+ /* End of multiple bits */
+
+ /** DISCRETE INPUTS **/
+ rc = modbus_read_input_bits(ctx, UT_INPUT_BITS_ADDRESS,
+ UT_INPUT_BITS_NB, tab_rp_bits);
+ printf("1/1 modbus_read_input_bits: ");
+
+ if (rc != UT_INPUT_BITS_NB) {
+ printf("FAILED (nb points %d)\n", rc);
+ goto close;
+ }
+
+ i = 0;
+ nb_points = UT_INPUT_BITS_NB;
+ while (nb_points > 0) {
+ int nb_bits = (nb_points > 8) ? 8 : nb_points;
+
+ value = modbus_get_byte_from_bits(tab_rp_bits, i*8, nb_bits);
+ if (value != UT_INPUT_BITS_TAB[i]) {
+ printf("FAILED (%0X != %0X)\n", value, UT_INPUT_BITS_TAB[i]);
+ goto close;
+ }
+
+ nb_points -= nb_bits;
+ i++;
+ }
+ printf("OK\n");
+
+ /** HOLDING REGISTERS **/
+
+ /* Single register */
+ rc = modbus_write_register(ctx, UT_REGISTERS_ADDRESS, 0x1234);
+ printf("1/2 modbus_write_register: ");
+ if (rc == 1) {
+ printf("OK\n");
+ } else {
+ printf("FAILED\n");
+ goto close;
+ }
+
+ rc = modbus_read_registers(ctx, UT_REGISTERS_ADDRESS,
+ 1, tab_rp_registers);
+ printf("2/2 modbus_read_registers: ");
+ if (rc != 1) {
+ printf("FAILED (nb points %d)\n", rc);
+ goto close;
+ }
+
+ if (tab_rp_registers[0] != 0x1234) {
+ printf("FAILED (%0X != %0X)\n",
+ tab_rp_registers[0], 0x1234);
+ goto close;
+ }
+ printf("OK\n");
+ /* End of single register */
+
+ /* Many registers */
+ rc = modbus_write_registers(ctx, UT_REGISTERS_ADDRESS,
+ UT_REGISTERS_NB, UT_REGISTERS_TAB);
+ printf("1/5 modbus_write_registers: ");
+ if (rc == UT_REGISTERS_NB) {
+ printf("OK\n");
+ } else {
+ printf("FAILED\n");
+ goto close;
+ }
+
+ rc = modbus_read_registers(ctx, UT_REGISTERS_ADDRESS,
+ UT_REGISTERS_NB, tab_rp_registers);
+ printf("2/5 modbus_read_registers: ");
+ if (rc != UT_REGISTERS_NB) {
+ printf("FAILED (nb points %d)\n", rc);
+ goto close;
+ }
+
+ for (i=0; i < UT_REGISTERS_NB; i++) {
+ if (tab_rp_registers[i] != UT_REGISTERS_TAB[i]) {
+ printf("FAILED (%0X != %0X)\n",
+ tab_rp_registers[i],
+ UT_REGISTERS_TAB[i]);
+ goto close;
+ }
+ }
+ printf("OK\n");
+
+ rc = modbus_read_registers(ctx, UT_REGISTERS_ADDRESS,
+ 0, tab_rp_registers);
+ printf("3/5 modbus_read_registers (0): ");
+ if (rc != 0) {
+ printf("FAILED (nb points %d)\n", rc);
+ goto close;
+ }
+ printf("OK\n");
+
+ nb_points = (UT_REGISTERS_NB >
+ UT_INPUT_REGISTERS_NB) ?
+ UT_REGISTERS_NB : UT_INPUT_REGISTERS_NB;
+ memset(tab_rp_registers, 0, nb_points * sizeof(uint16_t));
+
+ /* Write registers to zero from tab_rp_registers and store read registers
+ into tab_rp_registers. So the read registers must set to 0, except the
+ first one because there is an offset of 1 register on write. */
+ rc = modbus_write_and_read_registers(ctx,
+ UT_REGISTERS_ADDRESS + 1, UT_REGISTERS_NB - 1,
+ tab_rp_registers,
+ UT_REGISTERS_ADDRESS,
+ UT_REGISTERS_NB,
+ tab_rp_registers);
+ printf("4/5 modbus_write_and_read_registers: ");
+ if (rc != UT_REGISTERS_NB) {
+ printf("FAILED (nb points %d != %d)\n", rc, UT_REGISTERS_NB);
+ goto close;
+ }
+
+ if (tab_rp_registers[0] != UT_REGISTERS_TAB[0]) {
+ printf("FAILED (%0X != %0X)\n",
+ tab_rp_registers[0], UT_REGISTERS_TAB[0]);
+ }
+
+ for (i=1; i < UT_REGISTERS_NB; i++) {
+ if (tab_rp_registers[i] != 0) {
+ printf("FAILED (%0X != %0X)\n",
+ tab_rp_registers[i], 0);
+ goto close;
+ }
+ }
+ printf("OK\n");
+
+ /* End of many registers */
+
+
+ /** INPUT REGISTERS **/
+ rc = modbus_read_input_registers(ctx, UT_INPUT_REGISTERS_ADDRESS,
+ UT_INPUT_REGISTERS_NB,
+ tab_rp_registers);
+ printf("1/1 modbus_read_input_registers: ");
+ if (rc != UT_INPUT_REGISTERS_NB) {
+ printf("FAILED (nb points %d)\n", rc);
+ goto close;
+ }
+
+ for (i=0; i < UT_INPUT_REGISTERS_NB; i++) {
+ if (tab_rp_registers[i] != UT_INPUT_REGISTERS_TAB[i]) {
+ printf("FAILED (%0X != %0X)\n",
+ tab_rp_registers[i], UT_INPUT_REGISTERS_TAB[i]);
+ goto close;
+ }
+ }
+ printf("OK\n");
+
+ printf("\nTEST FLOATS\n");
+ /** FLOAT **/
+ printf("1/2 Set float: ");
+ modbus_set_float(UT_REAL, tab_rp_registers);
+ if (tab_rp_registers[1] == (UT_IREAL >> 16) &&
+ tab_rp_registers[0] == (UT_IREAL & 0xFFFF)) {
+ printf("OK\n");
+ } else {
+ printf("FAILED (%x != %x)\n",
+ *((uint32_t *)tab_rp_registers), UT_IREAL);
+ goto close;
+ }
+
+ printf("2/2 Get float: ");
+ real = modbus_get_float(tab_rp_registers);
+ if (real == UT_REAL) {
+ printf("OK\n");
+ } else {
+ printf("FAILED (%f != %f)\n", real, UT_REAL);
+ goto close;
+ }
+
+ printf("\nAt this point, error messages doesn't mean the test has failed\n");
+
+ /** ILLEGAL DATA ADDRESS **/
+ printf("\nTEST ILLEGAL DATA ADDRESS:\n");
+
+ /* The mapping begins at 0 and ends at address + nb_points so
+ * the addresses are not valid. */
+
+ rc = modbus_read_bits(ctx, UT_BITS_ADDRESS,
+ UT_BITS_NB + 1, tab_rp_bits);
+ printf("* modbus_read_bits: ");
+ if (rc == -1 && errno == EMBXILADD) {
+ printf("OK\n");
+ } else {
+ printf("FAILED\n");
+ goto close;
+ }
+
+ rc = modbus_read_input_bits(ctx, UT_INPUT_BITS_ADDRESS,
+ UT_INPUT_BITS_NB + 1, tab_rp_bits);
+ printf("* modbus_read_input_bits: ");
+ if (rc == -1 && errno == EMBXILADD)
+ printf("OK\n");
+ else {
+ printf("FAILED\n");
+ goto close;
+ }
+
+ rc = modbus_read_registers(ctx, UT_REGISTERS_ADDRESS,
+ UT_REGISTERS_NB + 1, tab_rp_registers);
+ printf("* modbus_read_registers: ");
+ if (rc == -1 && errno == EMBXILADD)
+ printf("OK\n");
+ else {
+ printf("FAILED\n");
+ goto close;
+ }
+
+ rc = modbus_read_input_registers(ctx, UT_INPUT_REGISTERS_ADDRESS,
+ UT_INPUT_REGISTERS_NB + 1,
+ tab_rp_registers);
+ printf("* modbus_read_input_registers: ");
+ if (rc == -1 && errno == EMBXILADD)
+ printf("OK\n");
+ else {
+ printf("FAILED\n");
+ goto close;
+ }
+
+ rc = modbus_write_bit(ctx, UT_BITS_ADDRESS + UT_BITS_NB, ON);
+ printf("* modbus_write_bit: ");
+ if (rc == -1 && errno == EMBXILADD) {
+ printf("OK\n");
+ } else {
+ printf("FAILED\n");
+ goto close;
+ }
+
+ rc = modbus_write_bits(ctx, UT_BITS_ADDRESS + UT_BITS_NB,
+ UT_BITS_NB, tab_rp_bits);
+ printf("* modbus_write_coils: ");
+ if (rc == -1 && errno == EMBXILADD) {
+ printf("OK\n");
+ } else {
+ printf("FAILED\n");
+ goto close;
+ }
+
+ rc = modbus_write_registers(ctx, UT_REGISTERS_ADDRESS + UT_REGISTERS_NB,
+ UT_REGISTERS_NB, tab_rp_registers);
+ printf("* modbus_write_registers: ");
+ if (rc == -1 && errno == EMBXILADD) {
+ printf("OK\n");
+ } else {
+ printf("FAILED\n");
+ goto close;
+ }
+
+
+ /** TOO MANY DATA **/
+ printf("\nTEST TOO MANY DATA ERROR:\n");
+
+ rc = modbus_read_bits(ctx, UT_BITS_ADDRESS,
+ MODBUS_MAX_READ_BITS + 1, tab_rp_bits);
+ printf("* modbus_read_bits: ");
+ if (rc == -1 && errno == EMBMDATA) {
+ printf("OK\n");
+ } else {
+ printf("FAILED\n");
+ goto close;
+ }
+
+ rc = modbus_read_input_bits(ctx, UT_INPUT_BITS_ADDRESS,
+ MODBUS_MAX_READ_BITS + 1, tab_rp_bits);
+ printf("* modbus_read_input_bits: ");
+ if (rc == -1 && errno == EMBMDATA) {
+ printf("OK\n");
+ } else {
+ printf("FAILED\n");
+ goto close;
+ }
+
+ rc = modbus_read_registers(ctx, UT_REGISTERS_ADDRESS,
+ MODBUS_MAX_READ_REGISTERS + 1,
+ tab_rp_registers);
+ printf("* modbus_read_registers: ");
+ if (rc == -1 && errno == EMBMDATA) {
+ printf("OK\n");
+ } else {
+ printf("FAILED\n");
+ goto close;
+ }
+
+ rc = modbus_read_input_registers(ctx, UT_INPUT_REGISTERS_ADDRESS,
+ MODBUS_MAX_READ_REGISTERS + 1,
+ tab_rp_registers);
+ printf("* modbus_read_input_registers: ");
+ if (rc == -1 && errno == EMBMDATA) {
+ printf("OK\n");
+ } else {
+ printf("FAILED\n");
+ goto close;
+ }
+
+ rc = modbus_write_bits(ctx, UT_BITS_ADDRESS,
+ MODBUS_MAX_WRITE_BITS + 1, tab_rp_bits);
+ printf("* modbus_write_bits: ");
+ if (rc == -1 && errno == EMBMDATA) {
+ printf("OK\n");
+ } else {
+ goto close;
+ printf("FAILED\n");
+ }
+
+ rc = modbus_write_registers(ctx, UT_REGISTERS_ADDRESS,
+ MODBUS_MAX_WRITE_REGISTERS + 1,
+ tab_rp_registers);
+ printf("* modbus_write_registers: ");
+ if (rc == -1 && errno == EMBMDATA) {
+ printf("OK\n");
+ } else {
+ printf("FAILED\n");
+ goto close;
+ }
+
+ /** SLAVE REPLY **/
+ printf("\nTEST SLAVE REPLY:\n");
+ modbus_set_slave(ctx, INVALID_SERVER_ID);
+ rc = modbus_read_registers(ctx, UT_REGISTERS_ADDRESS,
+ UT_REGISTERS_NB, tab_rp_registers);
+ if (use_backend == RTU) {
+ const int RAW_REQ_LENGTH = 6;
+ uint8_t raw_req[] = { INVALID_SERVER_ID, 0x03, 0x00, 0x01, 0xFF, 0xFF };
+ uint8_t rsp[MODBUS_TCP_MAX_ADU_LENGTH];
+
+ /* No response in RTU mode */
+ printf("1/4-A No response from slave %d: ", INVALID_SERVER_ID);
+
+ if (rc == -1 && errno == ETIMEDOUT) {
+ printf("OK\n");
+ } else {
+ printf("FAILED\n");
+ goto close;
+ }
+
+ /* Send an invalid query with a wrong slave ID */
+ modbus_send_raw_request(ctx, raw_req,
+ RAW_REQ_LENGTH * sizeof(uint8_t));
+ rc = modbus_receive_confirmation(ctx, rsp);
+
+ printf("1/4-B No response from slave %d with invalid request: ",
+ INVALID_SERVER_ID);
+
+ if (rc == -1 && errno == ETIMEDOUT) {
+ printf("OK\n");
+ } else {
+ printf("FAILED (%d)\n", rc);
+ goto close;
+ }
+
+ } else {
+ /* Response in TCP mode */
+ printf("1/4 Response from slave %d: ", 18);
+
+ if (rc == UT_REGISTERS_NB) {
+ printf("OK\n");
+ } else {
+ printf("FAILED\n");
+ goto close;
+ }
+ }
+
+ rc = modbus_set_slave(ctx, MODBUS_BROADCAST_ADDRESS);
+ if (rc == -1) {
+ printf("Invalid broacast address\n");
+ goto close;
+ }
+
+ rc = modbus_read_registers(ctx, UT_REGISTERS_ADDRESS,
+ UT_REGISTERS_NB, tab_rp_registers);
+ printf("2/4 Reply after a broadcast query: ");
+ if (rc == UT_REGISTERS_NB) {
+ printf("OK\n");
+ } else {
+ printf("FAILED\n");
+ goto close;
+ }
+
+ /* Restore slave */
+ if (use_backend == RTU) {
+ modbus_set_slave(ctx, SERVER_ID);
+ } else {
+ modbus_set_slave(ctx, MODBUS_TCP_SLAVE);
+ }
+
+ printf("3/4 Report slave ID: \n");
+ /* tab_rp_bits is used to store bytes */
+ rc = modbus_report_slave_id(ctx, tab_rp_bits);
+ if (rc == -1) {
+ printf("FAILED\n");
+ goto close;
+ }
+
+ /* Slave ID is an arbitraty number for libmodbus */
+ if (rc > 0) {
+ printf("OK Slave ID is %d\n", tab_rp_bits[0]);
+ } else {
+ printf("FAILED\n");
+ goto close;
+ }
+
+ /* Run status indicator */
+ if (rc > 1 && tab_rp_bits[1] == 0xFF) {
+ printf("OK Run Status Indicator is %s\n", tab_rp_bits[1] ? "ON" : "OFF");
+ } else {
+ printf("FAILED\n");
+ goto close;
+ }
+
+ /* Print additional data as string */
+ if (rc > 2) {
+ printf("Additional data: ");
+ for (i=2; i < rc; i++) {
+ printf("%c", tab_rp_bits[i]);
+ }
+ printf("\n");
+ }
+
+ /* Save original timeout */
+ modbus_get_response_timeout(ctx, &old_response_timeout);
+
+ /* Define a new and too short timeout */
+ response_timeout.tv_sec = 0;
+ response_timeout.tv_usec = 0;
+ modbus_set_response_timeout(ctx, &response_timeout);
+
+ rc = modbus_read_registers(ctx, UT_REGISTERS_ADDRESS,
+ UT_REGISTERS_NB, tab_rp_registers);
+ printf("4/4 Too short timeout: ");
+ if (rc == -1 && errno == ETIMEDOUT) {
+ printf("OK\n");
+ } else {
+ printf("FAILED (can fail on slow systems or Windows)\n");
+ }
+
+ /* Restore original timeout */
+ modbus_set_response_timeout(ctx, &old_response_timeout);
+
+ /* A wait and flush operation is done by the error recovery code of
+ * libmodbus */
+
+ /** BAD RESPONSE **/
+ printf("\nTEST BAD RESPONSE ERROR:\n");
+
+ /* Allocate only the required space */
+ tab_rp_registers_bad = (uint16_t *) malloc(
+ UT_REGISTERS_NB_SPECIAL * sizeof(uint16_t));
+ rc = modbus_read_registers(ctx, UT_REGISTERS_ADDRESS,
+ UT_REGISTERS_NB_SPECIAL, tab_rp_registers_bad);
+ printf("* modbus_read_registers: ");
+ if (rc == -1 && errno == EMBBADDATA) {
+ printf("OK\n");
+ } else {
+ printf("FAILED\n");
+ goto close;
+ }
+
+ free(tab_rp_registers_bad);
+
+ /** MANUAL EXCEPTION **/
+ printf("\nTEST MANUAL EXCEPTION:\n");
+
+ rc = modbus_read_registers(ctx, UT_REGISTERS_ADDRESS_SPECIAL,
+ UT_REGISTERS_NB, tab_rp_registers);
+ printf("* modbus_read_registers at special address: ");
+ if (rc == -1 && errno == EMBXSBUSY) {
+ printf("OK\n");
+ } else {
+ printf("FAILED\n");
+ goto close;
+ }
+
+ /** RAW REQUEST */
+ printf("\nTEST RAW REQUEST:\n");
+ {
+ const int RAW_REQ_LENGTH = 6;
+ uint8_t raw_req[] = { (use_backend == RTU) ? SERVER_ID : 0xFF,
+ 0x03, 0x00, 0x01, 0x0, 0x05 };
+ int req_length;
+ uint8_t rsp[MODBUS_TCP_MAX_ADU_LENGTH];
+
+ req_length = modbus_send_raw_request(ctx, raw_req,
+ RAW_REQ_LENGTH * sizeof(uint8_t));
+
+ printf("* modbus_send_raw_request: ");
+ if ((use_backend == RTU && req_length == (RAW_REQ_LENGTH + 2)) ||
+ ((use_backend == TCP || use_backend == TCP_PI) &&
+ req_length == (RAW_REQ_LENGTH + 6))) {
+ printf("OK\n");
+ } else {
+ printf("FAILED (%d)\n", req_length);
+ goto close;
+ }
+
+ printf("* modbus_receive_confirmation: ");
+ rc = modbus_receive_confirmation(ctx, rsp);
+ if ((use_backend == RTU && rc == 15) ||
+ ((use_backend == TCP || use_backend == TCP_PI) &&
+ rc == 19)) {
+ printf("OK\n");
+ } else {
+ printf("FAILED (%d)\n", rc);
+ goto close;
+ }
+ }
+
+ printf("\nALL TESTS PASS WITH SUCCESS.\n");
+
+close:
+ /* Free the memory */
+ free(tab_rp_bits);
+ free(tab_rp_registers);
+
+ /* Close the connection */
+ modbus_close(ctx);
+ modbus_free(ctx);
+
+ return 0;
+}
diff --git a/tests/unit-test-client.o b/tests/unit-test-client.o
new file mode 100644
index 0000000..8358604
--- /dev/null
+++ b/tests/unit-test-client.o
Binary files differ